/* _FileOp.c
Provides system-dependent file operation wrappers
(C) 1998 N. Douglas

Note that this is set up for Win32 - however, it should be alterable for the
vast majority of architectures out there thus making the whole program quite
portable
*/

/* Generic */
#include "_fileop.h"
#include "god.h"

#include <string.h>

extern char *_FileOp_Concantate(char *path, char *leaf)
{
  static char scratch[_MAX_PATH];
  strcpy(scratch, path);
  strcat(scratch, "\\");
  strcat(scratch, leaf);
  return scratch;
}

extern BOOLEAN _FileOp_BeginEnum(_FileOp_Enum *a, char *path)
{
  a->handle=FindFirstFile(_FileOp_Concantate(path,"*.jpg"), &a->data);
  if(a->handle==INVALID_HANDLE_VALUE) return FALSE;
  strcpy(a->rootpath, path);
  strcpy(a->path, _FileOp_Concantate(a->rootpath,a->data.cFileName));
  return TRUE;
}

extern BOOLEAN _FileOp_NextEnum(_FileOp_Enum *a)
{
  BOOL q;
  q=FindNextFile(a->handle,&a->data);
  if(q==0)
  {
    FindClose(a->handle);
    return FALSE;
  }
  strcpy(a->path, _FileOp_Concantate(a->rootpath,a->data.cFileName));
  return TRUE;
}

extern char *_FileOp_GetLeaf(char *path)
{
  if(strrchr(path,'\\')==0) return path;
  return strrchr(path,'\\')+1;
}

extern char *_FileOp_MakeUnix(char *path)
{
  static char scratch[_MAX_PATH];
  strcpy(scratch,path);
  while(strchr(scratch,'\\')!=0)
  {
    *strchr(scratch,'\\')='/';
  }
  return scratch;
}

extern char *_FileOp_ChangeType(char *path, char *type)
{
  static char scratch[_MAX_PATH];
  strcpy(scratch,path);
  strcpy(strrchr(scratch,'.')+1,type);
  return scratch;
}

extern BOOLEAN _FileOp_Exists(char *path)
{
  return (GetFileAttributes(path)==-1) ? FALSE : TRUE;
}

extern void _FileOp_CreateDir(char *path)
{
  CreateDirectory(path, NULL);
}

extern void _FileOp_MoveFile(char *from, char *to)
{
  MoveFile(from,to);
}
