/* _FileOp.h
See _FileOp.c
(C) 1998 N. Douglas
*/

#include <stdio.h>
#include <stdlib.h>

/* Required for Win32 */
#define WIN32_LEAN_AND_MEAN
#define WIN32_EXTRA_LEAN
#include "windows.h"

typedef struct _FileOp_Enum_t
{
  char path[_MAX_PATH];
  char rootpath[_MAX_PATH];
  HANDLE handle;
  WIN32_FIND_DATA data;
} _FileOp_Enum;

extern char *_FileOp_Concantate(char *path, char *leaf);

extern BOOLEAN _FileOp_BeginEnum(_FileOp_Enum *a, char *path);

extern BOOLEAN _FileOp_NextEnum(_FileOp_Enum *a);

extern char *_FileOp_GetLeaf(char *path);

extern char *_FileOp_MakeUnix(char *path);

extern char *_FileOp_ChangeType(char *path, char *type);

extern BOOLEAN _FileOp_Exists(char *path);

extern void _FileOp_CreateDir(char *path);

extern void _FileOp_MoveFile(char *from, char *to);
